<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- $Id: edittickets.php 4 2010-10-20 17:40:24Z scott_auge $ -->
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<title>ticketPortal | Edit Ticket</title>
<link href="styles.css" rel="stylesheet" type="text/css" />
</head>

<?php

include_once ("clsDB.php");
include_once ("clsTicket.php");
include_once ("clsCompanies.php");
include_once ("clsHTMLWidgets.php");
include_once ("clsUser.php");
include_once ("clsContacts.php");

include_once ("requireslogin.php");

$DB = new clsDB();
$Tickets = new clsTicket($DB);
$Companies = new clsCompanies($DB);
$HTML = new clsHTMLWidgets($DB);
$HTML->user_id = $Security->Data["user_id"];

if ($_REQUEST["action"] == "new") {

  $Tickets->Create();

  //
  // Author work around  IMHO it should be user_id.
  //

  $User = new clsUser($DB);
  $User->FindByID($Security->Data["user_id"]);
  $Contacts = new clsContacts($DB);
  $Contacts->FindByID($User->user_contact);

  $Tickets->author = $Contacts->contact_first_name . " " 
                   . $Contacts->contact_last_name . " <"
                   . $Contacts->contact_email . ">";


  //
  // Default company to user's company
  //

  $Tickets->ticket_company = $Security->Data["user_company"];
  
  $Tickets->Update();

  $Msg = "New Ticket Created";

} // if new




if ($_REQUEST["action"] == "update") {

  //
  // TODO: If the description changed, then make a note of the old description.
  //       May want to make this sysval optional.
  //


  //
  // Update  the ticket with new values.
  //

  $Tickets->FindByID($_REQUEST["ticket"]);
  
 	$Tickets->subject = $_REQUEST["Subject"];
  $Tickets->body = $_REQUEST["Description"];
  $Tickets->priority = $_REQUEST["TicketPriority"];
  $Tickets->type = $_REQUEST["TicketStatus"];
  $Tickets->ticket_project = $_REQUEST["Project"];
  $Tickets->activity = time();
	
  $Tickets->Update();

  //
  // If we have a note, then create a note ticket
  //

  if ($_REQUEST["NewNote"] != "") {

    $Note = new clsTicket(new clsDB());
    $Note->Create();
    
		$Note->parent = $Tickets->ticket;
    $Note->body = $_REQUEST["NewNote"];
    $Note->activity = time();
		$Note->timestamp = time();
    $Note->type = "ticketPortal";

    //
    // Defaults because not NULL db defs cause auto-rollback
    //

    $Note->ticket_company = 0;
    $Note->ticket_project = 0;
    $Note->recipient = "";
    $Note->subject = "";
    $Note->attachment = 0;
    $Note->assignment = 9999;
    $Note->activity = 0;
    $Note->priority = 0;
    $Note->cc = "";
    $Note->signature = "";

    //
    // Author work around  IMHO it should be user_id.
    //

    $User = new clsUser($DB);
    $User->FindByID($Security->Data["user_id"]);
    $Contacts = new clsContacts($DB);
    $Contacts->FindByID($User->user_contact);

    $Note->author = $Contacts->contact_first_name . " "
                  . $Contacts->contact_last_name . " <"
                  . $Contacts->contact_email . ">";

    $Note->Update();

  } // if NewNote != ""




  //
  //  Interface feedback to the user something happened.
  //

  $Msg = "Ticket Updated";

} // if update

//
// For rendering the page
//

$Tickets->FindByID($_REQUEST["ticket"]);
$Companies->FindByID($Tickets->ticket_company);

//
// Prevent user from simply using an URL to with ticket set to whatever from
// messing around with the ticket.
//

$ShowTicket = false;
if ($Security->Data["user_company"] == 0 || $Security->Data["user_company"] == $Tickets->ticket_company)
  $ShowTicket = true;
else
  $Msg = "Not your ticket!";

?>

<body><?php include("menu.php") ?>
<?php if ($ShowTicket) { ?>
<form method="post">
<input type="hidden" name="action" value="update" />
<input type="hidden" name="ticket" value="<?php print ($Tickets->ticket) ?>" />
<p class="SectionHeader">Ticket Information</p>
<table width="95%" align="center">
  <tr>
    <td valign="top"><table width="100%">
      <tr>
        <td><div align="right" class="FieldName">Ticket No: </div></td>
        <td class="DataField"><?php print($Tickets->ticket) ?></td>
      </tr>
      <tr>
        <td class="FieldName"><div align="right">Subject:</div></td>
        <td><input name="Subject" type="text" id="Subject" value="<?php print ($Tickets->subject) ?>" size="40"/></td>
      </tr>
      <tr>
        <td class="FieldName"><div align="right">Project:</div></td>
        <td><?php print ($HTML->ProjectsSelection("Project", $Tickets->ticket_project)) ?></td>
      </tr>
      <tr>
        <td class="FieldName"><div align="right">Company:</div></td>
        <td class="DataField"><?php print ($Companies->company_name) ?></td>
      </tr>
      <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
      </tr>
    </table></td>
    <td valign="top"><table width="100%">
      <tr>
        <td><div align="right" class="FieldName">Status:</div></td>
        <td><?php print ($HTML->TicketStatusSelection("TicketStatus", $Tickets->type) ) ?></td>
      </tr>
      <tr>
        <td class="FieldName"><div align="right">Priority:</div></td>
        <td><?php print ($HTML->TicketPrioritySelection("TicketPriority", $Tickets->priority) ) ?></td>
      </tr>
    </table></td>
  </tr>
  <tr>
    <td colspan="2" valign="top"><div align="center"><span class="FieldName">Ticket Description:</span><br />
        <textarea name="Description" cols="80" rows="10" class="DataField" id="Description"><?php print ($Tickets->body) ?></textarea>
    </div></td>
    </tr>
  <tr>
    <td colspan="2" valign="top"><div align="center">
      <input type="submit" name="Submit" value="Save" />
    </div></td>
    </tr>
</table>

<?php } // if $ShowTicket ?>
<p align="center" class="ErrorMessage"><?php print($Msg) ?></p>
<?php if ($ShowTicket) { ?>
<p class="SectionHeader">Notes:</p>


<table align="center">
	<tr>
	  <td colspan="2"><p align="center" class="FieldName">New Note:<br />
	        <textarea name="NewNote" cols="80" rows="10" class="DataField" id="NewNote"></textarea>
	  </p>
	    <p align="center">
	      <input type="submit" name="Submit2" value="Save" />
</p></td>
	  </tr>
</table>


<?php

//
// Notes are kept in the ticket table with a parent equal to the given ticket.
//

$NoteTicket = new clsTicket (new clsDB());
$SQL = "SELECT ticket FROM tickets WHERE parent = ? order by timestamp";
$S = $DB->Connection->prepare($SQL);
$S->bind_param("i", $Tickets->ticket);
$S->execute();
$S->store_result();
$S->bind_result($NoteTicketID);

while ($S->fetch()) {
  $NoteTicket->FindByID($NoteTicketID);
  ?>
  <hr />
  <table width="100%">
	
	<tr>
    <td width="27%"><span class="FieldName">Type:</span><span class="DataField"><?php print ($NoteTicket->type) ?></span></td>
		<td width="36%"><span class="FieldName">Date:</span><span class="DataField"><?php print (date(DATE_COOKIE,$NoteTicket->timestamp)) ?></span></td>
    <td width="37%"><span class="FieldName">Author:</span> <span class="DataField"><?php print ($NoteTicket->author) ?></span></td>
	</tr>
  
	<tr>
    <td colspan="3"><span class="DataField"><?php print ($NoteTicket->body) ?></span></td>
  </tr>
	<tr><td colspan="3"><hr /></td></tr>
</table>
  <?php
} // while

$S->close();
?>
</form>
<?php } // if $ShowTicket ?>
</body>
</html>
