<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- $Id: listtickets.php 21 2010-10-22 07:00:05Z scott_auge $ -->
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<title>ticketPortal | List Tickets</title>
<link href="styles.css" rel="stylesheet" type="text/css" />
</head>
<?php
include_once ("clsDB.php");
include_once ("clsTicket.php");
include_once ("clsProjects.php");
include_once ("clsSysvals.php");
include_once ("clsCompanies.php");
include_once ("clsPriority.php");
include_once ("clsUserSysval.php");

include_once ("requireslogin.php");

$DB = new clsDB();
$ClsDB = new clsDB();
$Ticket = new clsTicket($ClsDB);
$Project = new clsProjects($ClsDB);
$Company = new clsCompanies($ClsDB);
$Priority = new clsPriority($ClsDB);

//
// Can delete ticket here
//

if ($_REQUEST["action"] == "delete") {

  $Ticket->FindByID($_REQUEST["ticket"]);
	$Ticket->Delete();
	
}

//
// Present available tickets
//
// The user can be assoicated with a company or not.  If not, we want them to see
// all the tickets available.
//

if ($Security->Data["user_company"] == 0) {

  $SQL = "SELECT ticket FROM tickets WHERE parent = 0";
  $S = $DB->Connection->prepare($SQL);

} else {
  
  $SQL = "SELECT ticket FROM tickets WHERE parent = 0 AND tickets.ticket_company = ?";
  $S = $DB->Connection->prepare($SQL);
  $S->bind_param("s", $Security->Data["user_company"]);

} // else


$S->bind_result($TicketID);
$S->execute();

// If this is a GET, look up their preferred sysval and assign $_REQUEST values appropriately.

if ( $_SERVER['REQUEST_METHOD'] == "GET") {

  $UserVal = new clsUserSysval(new clsDB(), $Security->Data["user_id"]);
	$UserVal->FindByTitle("TicketListTypes");
	if ( $UserVal->Available() ) {
	
		$Setting = unserialize($UserVal->SysVal->sysval_value);
		if ( $Setting["ShowOpen"] ) $_REQUEST["ShowOpen"] = "checked";
		if ( $Setting["ShowClosed"] ) $_REQUEST["ShowClosed"] = "checked";
		if ( $Setting["ShowDeleted"] ) $_REQUEST["ShowDeleted"] = "checked";
		if ( $Setting["ShowProcessing"] ) $_REQUEST["ShowProcessing"] = "checked";
		if ( $Setting["ShowOnHold"] ) $_REQUEST["ShowOnHold"] = "checked";
	
	} // available preference		
	
} // if GET

// if this is a POST, then set the sysval preference for later use.

if ( $_SERVER['REQUEST_METHOD'] == "POST") {

	$Setting["ShowOpen"] = ($_REQUEST["ShowOpen"]) ? "checked" : "";
	$Setting["ShowClosed"] = ($_REQUEST["ShowClosed"]) ? "checked" : "";
	$Setting["ShowDeleted"] = ($_REQUEST["ShowDeleted"]) ? "checked" : "";
	$Setting["ShowProcessing"] = ($_REQUEST["ShowProcessing"]) ? "checked" : "";
	$Setting["ShowOnHold"] = ($_REQUEST["ShowOnHold"]) ? "checked" : "";
	
	$UserVal = new clsUserSysval(new clsDB(), $Security->Data["user_id"]);
	$UserVal->FindByTitle("TicketListTypes");
	if ( ! $UserVal->Available() ) $UserVal->Create();
	$UserVal->SetValue("TicketListTypes",serialize($Setting));
	$UserVal->Update();
	
} // if POST

?>

<body>
<div align="center">
  <?php include ("menu.php") ?>
  <form id="form1" name="form1" method="post" action="">
    <span class="FieldName">Show:</span>
    <input name="ShowOpen" type="checkbox" id="ShowOpen" value="checked" <?php if ($_REQUEST["ShowOpen"]) print("checked=\"checked\""); ?> />  
    <span class="DataField">Open</span> 
   <input name="ShowProcessing" type="checkbox" id="ShowProcessing" value="checked" <?php if ($_REQUEST["ShowProcessing"]) print("checked=\"checked\""); ?> /> 
   <span class="DataField">Processing</span>
  <input name="ShowClosed" type="checkbox" id="ShowClosed" value="checked" <?php if ($_REQUEST["ShowClosed"]) print("checked=\"checked\""); ?> />
  <span class="DataField">Closed</span> 
  <input name="ShowDeleted" type="checkbox" id="ShowDeleted" value="checked" <?php if ($_REQUEST["ShowDeleted"]) print("checked=\"checked\""); ?> />
  <span class="DataField">Deleted</span> 
  <input name="ShowOnHold" type="checkbox" id="ShowOnHold" value="checked" <?php if ($_REQUEST["ShowOnHold"]) print("checked=\"checked\""); ?> />
  <span class="DataField">On Hold</span> 
  <input type="submit" name="Submit" value="Refresh" />
  </form>
  <br />
</div>
<table width="95%" align="center">
  <tr>
    <td width="5%"><div align="center"><a href="edittickets.php?action=new"><img src="images/001.png" width="16" height="16" border="0" /></a></div></td>
    <td width="5%" bgcolor="#CCCCCC" class="FieldName"><div align="center">Ticket No </div></td>
    <td width="27%" bgcolor="#CCCCCC" class="FieldName"><div align="center">Subject</div></td>
    <td width="9%" bgcolor="#CCCCCC" class="FieldName"><div align="center">Type</div></td>
    <td width="10%" bgcolor="#CCCCCC" class="FieldName"><div align="center">Priority</div></td>
    <td width="23%" bgcolor="#CCCCCC" class="FieldName"><div align="center">Project</div></td>
    <td width="21%" bgcolor="#CCCCCC" class="FieldName"><div align="center">Company</div></td>
  </tr>
	<?php
	while ($S->fetch()) {

	  $Ticket->FindByID($TicketID);
		$Project->FindByID($Ticket->ticket_project);
		$Company->FindByID($Ticket->ticket_company);
				
		// Skip over what the useer has not checked as viewable
		
		if ( ! $_REQUEST["ShowOpen"] && $Ticket->type == "Open") continue;
		if ( ! $_REQUEST["ShowClosed"] && $Ticket->type == "Closed") continue;
		if ( ! $_REQUEST["ShowDeleted"] && $Ticket->type == "Deleted") continue;
		if ( ! $_REQUEST["ShowProcessing"] && $Ticket->type == "Processing") continue;
		if ( ! $_REQUEST["ShowOnHold"] && $Ticket->type == "On Hold") continue;
		
	?>
  <tr>
    <td><div align="center"><a href="listtickets.php?ticket=<?php print ($Ticket->ticket) ?>&action=delete"><img src="images/004.png" width="16" height="16" border="0" /></a> &nbsp;<a href="edittickets.php?ticket=<?php print ($Ticket->ticket) ?>"><img src="images/017.png" width="16" height="16" border="0" /></a></div></td>
    <td class="DataField"><div align="center"><?php print ($Ticket->ticket) ?></div></td>
    <td class="DataField"><div align="center"><?php print ($Ticket->subject) ?></div></td>
    <td class="DataField"><div align="center"><?php print ($Ticket->type) ?></div></td>
    <td class="DataField"><div align="center"><?php print ($Priority->NumberToName($Ticket->priority)) ?></div></td>
    <td class="DataField"><div align="center"><?php print ($Project->project_name) ?></div></td>
    <td class="DataField"><div align="center"><?php print ($Company->company_name) ?></div></td>
  </tr>
	<?php
	} // while ()
	?>
</table>
<p>&nbsp;</p>
<?php include_once("footer.php") ?>
</body>
</html>
